/*
 * DIRB
 *
 * get_url.h - get_url defines
 *
 */

#include "global.h"



// Codigos de error curl

static struct code error2message[] = {
  { CURLE_OK, "OK" },
  { CURLE_UNSUPPORTED_PROTOCOL, "UNSUPPORTED PROTOCOL"  },
  { CURLE_FAILED_INIT, "FAILED INIT"  },
  { CURLE_URL_MALFORMAT, "URL MALFORMAT" },
  { CURLE_URL_MALFORMAT_USER, "URL MALFORMAT (USER)"  },
  { CURLE_COULDNT_RESOLVE_PROXY, "COULDNT RESOLVE PROXY" },
  { CURLE_COULDNT_RESOLVE_HOST, "COULDNT RESOLVE HOST" },
  { CURLE_COULDNT_CONNECT, "COULDNT CONNECT" },
  { CURLE_FTP_WEIRD_SERVER_REPLY, "FTP WEIRD SERVER REPLY" },
  { CURLE_FTP_ACCESS_DENIED, "FTP ACCESS DENIED" },
  { CURLE_FTP_USER_PASSWORD_INCORRECT, "FTP USER PASSWORD INCORRECT" },
  { CURLE_FTP_WEIRD_PASS_REPLY, "FTP WEIRD PASS REPLY" },
  { CURLE_FTP_WEIRD_USER_REPLY, "FTP WEIRD USER REPLY" },
  { CURLE_FTP_WEIRD_PASV_REPLY, "FTP WEIRD PASV REPLY" },
  { CURLE_FTP_WEIRD_227_FORMAT, "FTP WEIRD 227 FORMAT" },
  { CURLE_FTP_CANT_GET_HOST, "FTP CANT GET HOST" },
  { CURLE_FTP_CANT_RECONNECT, "FTP CANT RECONNECT" },
  { CURLE_FTP_COULDNT_SET_BINARY, "FTP COULDNT SET BINARY" },
  { CURLE_PARTIAL_FILE, "PARTIAL FILE" },
  { CURLE_FTP_COULDNT_RETR_FILE, "FTP COULDNT RETR FILE" },
  { CURLE_FTP_WRITE_ERROR, "FTP WRITE ERROR" },
  { CURLE_FTP_QUOTE_ERROR, "FTP QUOTE ERROR" },
  { CURLE_HTTP_RETURNED_ERROR, "HTTP RETURNED ERROR" },
  { CURLE_WRITE_ERROR, "WRITE ERROR" },
  { CURLE_MALFORMAT_USER, "MALFORMAT USER" },
  { CURLE_FTP_COULDNT_STOR_FILE, "FTP COULDNT STOR FILE" },
  { CURLE_READ_ERROR, "READ ERROR" },
  { CURLE_OUT_OF_MEMORY, "OUT OF MEMORY" },
  { CURLE_OPERATION_TIMEOUTED, "OPERATION TIMEOUT" },
  { CURLE_FTP_COULDNT_SET_ASCII, "FTP COULDNT SET ASCII" },
  { CURLE_FTP_PORT_FAILED, "FTP PORT FAILED" },
  { CURLE_FTP_COULDNT_USE_REST, "FTP COULDNT USE REST" },
  { CURLE_FTP_COULDNT_GET_SIZE, "FTP COULDNT GET SIZE" },
  { CURLE_HTTP_RANGE_ERROR, "HTTP RANGE ERROR" },
  { CURLE_HTTP_POST_ERROR, "HTTP POST ERROR" },
  { CURLE_SSL_CONNECT_ERROR, "SSL CONNECT ERROR" },
  { CURLE_BAD_DOWNLOAD_RESUME, "BAD DOWNLOAD RESUME" },
  { CURLE_FILE_COULDNT_READ_FILE, "FILE COULDNT READ FILE" },
  { CURLE_LDAP_CANNOT_BIND, "LDAP CANNOT BIND" },
  { CURLE_LDAP_SEARCH_FAILED, "LDAP SEARCH FAILED" },
  { CURLE_LIBRARY_NOT_FOUND, "LIBRARY NOT FOUND" },
  { CURLE_FUNCTION_NOT_FOUND, "FUNCTION NOT FOUND" },
  { CURLE_ABORTED_BY_CALLBACK, "ABORTED BY CALLBACK" },
  { CURLE_BAD_FUNCTION_ARGUMENT, "BAD FUNCTION ARGUMENT" },
  { CURLE_BAD_CALLING_ORDER, "BAD CALLING ORDER" },
  { CURLE_HTTP_PORT_FAILED, "HTTP PORT FAILED" },
  { CURLE_BAD_PASSWORD_ENTERED, "BAD PASSWORD ENTERED" },
  { CURLE_TOO_MANY_REDIRECTS, "TOO MANY REDIRECTS" },
  { CURLE_UNKNOWN_TELNET_OPTION, "UNKNOWN TELNET OPTION" },
  { CURLE_TELNET_OPTION_SYNTAX, "TELNET OPTION SYNTAX" },
  { CURLE_OBSOLETE, "OBSOLETE" },
  { CURLE_SSL_PEER_CERTIFICATE, "INVALID SSL PEER CERTIFICATE" },
  { CURLE_GOT_NOTHING, "EMPTY REPLY FROM SERVER" },
  { CURLE_SSL_ENGINE_NOTFOUND, "SSL ENGINE NOTFOUND" },
  { CURLE_SSL_ENGINE_SETFAILED, "SSL ENGINE SETFAILED" },
  { CURLE_SEND_ERROR, "SEND ERROR" },
  { CURLE_RECV_ERROR, "RECV ERROR" },
  { CURLE_SHARE_IN_USE, "SHARE IN USE" },
  { CURLE_SSL_CERTPROBLEM, "SSL CERTIFICATE PROBLEM" },
  { CURLE_SSL_CIPHER, "WRONG SSL CIPHER" },
  { CURLE_SSL_CACERT, "WRONG SSL CA CERTIFICATE" },
//  { CURLE_BAD_CONTENT_ENCODING, "BAD CONTENT ENCODING" },
//  { CURLE_LDAP_INVALID_URL, "LDAP INVALID URL" },
//  { CURLE_FILESIZE_EXCEEDED, "FILESIZE EXCEEDED" },
  { 0, "" }
};



